*$ CREATE STUPRF.FOR
*COPY STUPRF
*
*=== stuprf ===========================================================*
*
      SUBROUTINE STUPRF ( IJ, MREG, XX, YY, ZZ, NPSECN, NPPRMR )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1997-2005      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     SeT User PRoperties for Fluka particles:                         *
*                                                                      *
*     Created on  09 october 1997  by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on  14-jul-05    by    Alfredo Ferrari               *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(EVTFLG)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(TRACKR)'
*
c     add some more commons
      INCLUDE '(GENSTK)' !properties of secondaries created in a hadronic event
      INCLUDE '(PAPROP)'        !particle properties (mass, charge...)

c     logical variable to do initialization only the first time
      LOGICAL LFIRST
      DATA LFIRST / .TRUE. /
      SAVE LFIRST

      IF ( LFIRST ) THEN
         LFIRST = .FALSE.
         WRITE (LUNOUT,*) "stuprf.f correctly called!"
         CALL FFLUSH
         CALL FFLUSH(LUNOUT)
      END IF
      
      LOUSE   (NPFLKA)  = LLOUSE
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = SPAUSR (ISPR)
  100 CONTINUE
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = ISPUSR (ISPR)
  200 CONTINUE
*  Increment the track number and put it into the last flag:
      IF ( NPSECN .GT. NPPRMR ) THEN
         IF ( NTRCKS .EQ. 2000000000 ) NTRCKS = -2000000000
         NTRCKS = NTRCKS + 1
         ISPARK (MKBMX2,NPFLKA) = NTRCKS
      END IF

c     check if is a new particle
      IF ( NPSECN .GT. NPPRMR ) THEN
         WRITE(51,*) KPART(NPSECN), TKI(NPSECN), CZR(NPSECN)
      END IF
      
      RETURN
*=== End of subroutine Stuprf =========================================*
      END

